000101150603     H  DFTACTGRP(*NO) ACTGRP(*CALLER) DATFMT(*ISO) TIMFMT(*ISO)
000102150603     H  OPTION(*NOUNREF: *NODEBUGIO)   EXPROPTS(*RESDECPOS)
000103150603     H  BNDDIR('QSYS/QC2LE')
000104150601      //---------------------------------------------------------
000105150601      // PDFSPLFR - List spool files with Options
000106150601      // call Quslspl API to load selected spooled files to user space.
000107150601      // display subfile of selected spooled files.
000108150601      // process options selected from subfile.
000109150601      // Uses SPLF0300 format which is way faster than WRKSPLF
000110150601      //---------------------------------------------------------
000111150601
000114150603     FPDFSPLFD  cf   e             workstn sfile(SBFDTA1: rrn) infds(Infds)
000115150603     F                                     sfile(SBFDTA2: rrn) indds(Ind)
000116150603     F                                     sfile(SBFDTA3: rrn)
000117150603     F                                     sfile(SBFDTA4: rrn)
000118150601
000119150601      //--*STAND ALONE-------------------------------------------
000120150603     D UsrPrf          s             10a   inz(*user)
000121150603     D OptionSav       s                   like(sbfOption)
000122150603     D SflRcdNbrSav    s                   like(SflRcdNbr)
000123150603     D NextViewSav     s              1s 0
000124150603     D rrnx            s              5u 0
000125150603     D LastRrn         s              5u 0
000126150603     D IsView1         s               n
000127150603     D IsView2         s               n
000128150603     D IsView3         s               n
000129150603     D IsView4         s               n
000130150603     D IsOption4       s               n
000131150603
000142150603     D rrn             s              5u 0
000143150603     D aa              s              5u 0
000144150603     D bb              s              5u 0
000145150603     D cc              s              5u 0
000146150603     D qs              c                   const('''')                          single quote
000147150603     D qd              c                   const('"')                           double quote
000148150603     D up              c                   const('ABCDEFGHIJKLMNOPQRSTUVWXYZ')
000149150603     D lo              c                   const('abcdefghijklmnopqrstuvwxyz')
000150150603     D IsExitPgm       s               n
000151150603     D IsRefresh       s               n
000152150603     D IsFirstTime     s               n
000153150603     D IsComment       s               n
000154150603
000155150603     D f01             c                   const(x'31')
000156150603     D f02             c                   const(x'32')
000157150603     D f03             c                   const(x'33')
000158150603     D f04             c                   const(x'34')
000159150603     D f05             c                   const(x'35')
000160150603     D f06             c                   const(x'36')
000161150603     D f07             c                   const(x'37')
000162150603     D f08             c                   const(x'38')
000163150603     D f09             c                   const(x'39')
000164150603     D f10             c                   const(x'3A')
000165150603     D f11             c                   const(x'3B')
000166150603     D f12             c                   const(x'3C')
000167150603     D f13             c                   const(x'B1')
000168150603     D f14             c                   const(x'B2')
000169150603     D f15             c                   const(x'B3')
000170150603     D f16             c                   const(x'B4')
000171150603     D f17             c                   const(x'B5')
000172150603     D f18             c                   const(x'B6')
000173150603     D f19             c                   const(x'B7')
000174150603     D f20             c                   const(x'B8')
000175150603     D f21             c                   const(x'B9')
000176150603     D f22             c                   const(x'BA')
000177150603     D f23             c                   const(x'BB')
000178150603     D f24             c                   const(x'BC')
000179150603     D fPageup         c                   const(x'F4')
000180150603     D fPageDown       c                   const(x'F5')
000181150603
000182150603     D  Green          c                   const(x'20')
000183150603     D  White          c                   const(x'22')
000184150603     D  Red            c                   const(x'28')
000185150603     D  Turq           c                   const(x'30')
000186150603     D  Yellow         c                   const(x'32')
000187150603     D  Pink           c                   const(x'38')
000188150603     D  Blue           c                   const(x'3A')
000189150603     D  ND             c                   const(x'27')
000190150603     D  RI             c                   const(x'01')
000191150603     D  HI             c                   const(x'02')
000192150603     D  UL             c                   const(x'04')
000193150603     D  PR             c                   const(x'80')
000194150603
000195150603 2b  D IsSndSplf       s               n
000196150603 2b  D IsEsend         s               n
000197150603 2b  D IsOneTime       s               n   inz(*on)
000198150603     D EmailAddr       s             60a
000199150603     D oE              c                   const('E=ESndMail   ')
000200150603     D oS              c                   const('S=SndSplf  ')
000201150603     D o2              c                   const('2=Change  ')
000202150603     D o3              c                   const('3=Hold   ')
000203150603     D o4              c                   const('4=Delete   ')
000204150603     D o5              c                   const('5=Display')
000205150603
000206150601       // Import C/C++ global variable
000207150603     D EXCP_MSGID      s              7a   import('_EXCP_MSGID')
000209150601
000210150601       // error return code parm for APIs.
000211150607     D ApiErrDS        DS                  qualified
000212150603     D  BytesProvided                10i 0
000213150603     D  BytesReturned                10i 0
000214150603     D  ErrMsgId                      7a
000215150603     D  ReservedSpace                 1a
000216150603     D  MsgReplaceVal               112a
000217150603
000218150601
000219150601       //---------------------------------------------------------
000220150601       // File information Data Structure
000221150603     D Infds           DS
000222150603     D  InfdsFile                    10a   overlay(Infds:83)
000223150603     D  InfdsLib                     10a   overlay(Infds:93)
000224150603     D  InfdsRecLen                   5i 0 overlay(Infds:125)
000225150603     D  InfdsMbr                     10a   overlay(Infds:129)
000226150603     D  InfdsNumRcds                 10i 0 overlay(Infds:156)
000227150603     D  InfdsMiscFlag                 1a   overlay(Infds:196)
000228150603     D  InfdsCcsid                    5i 0 overlay(Infds:218)
000229150603     D  InfdsRcdfmt                  10a   overlay(Infds:261)
000230150603     D  InfdsFkey                     1a   overlay(Infds:369)
000231150603     D  SflRecNbrX                    5i 0 overlay(Infds:376)
000232150603     D  SflRecNbr                     5i 0 overlay(Infds:378)
000233150603
000234150601
000235150601      //--*DATA STRUCTURES---------------------------------------
000236150603     D PSDS           SDS
000237150603     D  progid                       10a   Overlay(PSDS)
000239150603
000243150601       // Get user space list info from header section.
000244150603     D GenericHeader   DS                  qualified based(GenericHeaderPtr)
000245150603     D SizeOfUsrSpc                  10i 0 overlay(GenericHeader:105)
000246150603     D OffSetToHeader                10i 0 overlay(GenericHeader:117)
000247150603     D OffSetToList                  10i 0 overlay(GenericHeader:125)
000248150603     D ListEntryCount                10i 0 overlay(GenericHeader:133)
000249150603     D ListEntrySize                 10i 0 overlay(GenericHeader:137)
000250150603     D UserSpaceName   s             20a   inz('JCRCMDS   QTEMP     ')
000251150603     D ForCount        s             10i 0
000252150603
000253150603       // Parameters for CEEGSI - Get String Information
000254150603     D ceegsi          PR                  extproc('CEEGSI')                    get string info
000255150603     D position                      10i 0 const                                position
000256150603     D dataLength                    10i 0                                      data type
000257150603     D parmLength                    10i 0                                      parm length
000258150603     D maxLength                     10i 0                                      max length
000259150603     D feedback                      12a          options(*omit)                feedback
000260150607
000261150603      // CEEGSI values used in multiple functions
000262150607     D MaxLen          s             10i 0
000263150603     D DataType        s             10i 0
000264150603     D ParmLen         s             10i 0
000265150603
000274150601       // name screen indicators
000275150603     D ind             DS                  qualified inz
000276150603     D IsActivateF14                   n   overlay(ind:04)
000277150603     D IsKeysMode                      n   overlay(ind:05)
000278150603     D sfldrop                         n   overlay(ind:06)
000279150603     D IsMoreScreens                   n   overlay(ind:08)
000280150603     D IsShowViewPFs                   n   overlay(ind:09)
000281150603     D HeadingSwitch                   n   overlay(ind:10)
000282150603     D sflnxtchg                       n   overlay(ind:11)
000283150603     D IsChangedDate                   n   overlay(ind:20)
000284150603     D ShowSrcData                     n   overlay(ind:27)
000285150603     D sfldsp                          n   overlay(ind:31)
000286150603     D sfldspctl                       n   overlay(ind:32)
000287150603     D sflclr                          n   overlay(ind:33)
000288150603     D sflend                          n   overlay(ind:34)
000289150603     D sfldsp2                         n   overlay(ind:41)
000290150603     D sfldspctl2                      n   overlay(ind:42)
000291150603     D sflclr2                         n   overlay(ind:43)
000292150603     D sflend2                         n   overlay(ind:44)
000293150603     D sfldsp3                         n   overlay(ind:51)
000294150603     D sfldspctl3                      n   overlay(ind:52)
000295150603     D sfldsp4                         n   overlay(ind:61)
000296150603     D sfldspctl4                      n   overlay(ind:62)
000297150603
000298150612       // Prototypes for Internal Subprocedures (needed for targeting V6.1)
000299150612
000300150603     D System          PR            10i 0 extproc('system')                    cl command processor
000301150603     D                                 *   value options(*string)
000302150603
000303150603     D Qmhsndpm        PR                  extpgm('QMHSNDPM')                   send program message
000304150603     D                                7a   const                                message id
000305150603     D                               20a   const                                file and lib
000306150603     D                               75a   const                                text
000307150603     D                               10i 0 const                                length
000308150603     D                               10a   const                                type
000309150603     D                               10a   const                                queue
000310150603     D                               10i 0 const                                stack entry
000311150607     D                                4a   const                                key
000312150607     D   errDS                             like(ApiErrDS)
000313150603
000316150601
000317150601     D Quslspl         PR                  extpgm('QUSLSPL')                    list spooled files
000318150601     D                               20a                                        user space
000319150601     D                                8a   const                                api format
000320150601     D                               10a   const                                user profile
000321150601     D                               20a                                        outq and lib
000322150601     D                               10a   const                                form type
000323150601     D                               10a   const                                user data
000324150601     Db                                    like(ApiErrDS)
000325150601     D QuslsplDS       DS                  qualified based(QuslsplPtr)
000326150601     D InternalJobID                 16a   overlay(QuslsplDS:51)
000327150601     D InternalSplfID                16a   overlay(QuslsplDS:67)
000328150601
000329150612     D f_RmvSflMsg     PR
000330150612     D  p_ProgName                   10a   const
000331150612
000332150612     D f_DayOfWeekNumber...
000333150612     D                 PR             3u 0                                      Day Of Week
000334150612     D  p_DateISO                      d    const
000335150612
000336150612     D f_GetDayName    PR             9a                                        Day Name
000337150612     D  p_DateISO                      d   Const options(*NoPass)               ISO Date
000338150612
000339150612     D f_Quscrtus      PR              *
000340150612     D  p_UserSpace                  20a
000341150612
000342150612     D f_BuildString   PR          2048a   opdesc
000343150612     D  pString                    2048a   const options(*varsize)
000344150612     D  pParm01                     100a   const options(*nopass:*varsize:*trim)
000345150612     D  pParm02                     100a   const options(*nopass:*varsize:*trim)
000346150612     D  pParm03                     100a   const options(*nopass:*varsize:*trim)
000347150612     D  pParm04                     100a   const options(*nopass:*varsize:*trim)
000348150612     D  pParm05                     100a   const options(*nopass:*varsize:*trim)
000349150612     D  pParm06                     100a   const options(*nopass:*varsize:*trim)
000350150612     D  pParm07                     100a   const options(*nopass:*varsize:*trim)
000351150612     D  pParm08                     100a   const options(*nopass:*varsize:*trim)
000352150612     D  pParm09                     100a   const options(*nopass:*varsize:*trim)
000353150612     D  pParm10                     100a   const options(*nopass:*varsize:*trim)
000354150612     D  pParm11                     100a   const options(*nopass:*varsize:*trim)
000355150612     D  pParm12                     100a   const options(*nopass:*varsize:*trim)
000356150612     D  pParm13                     100a   const options(*nopass:*varsize:*trim)
000357150612     D  pParm14                     100a   const options(*nopass:*varsize:*trim)
000358150612     D  pParm15                     100a   const options(*nopass:*varsize:*trim)
000359150612     D  pParm16                     100a   const options(*nopass:*varsize:*trim)
000360150612     D  pParm17                     100a   const options(*nopass:*varsize:*trim)
000361150612     D  pParm18                     100a   const options(*nopass:*varsize:*trim)
000362150612     D  pParm19                     100a   const options(*nopass:*varsize:*trim)
000363150612     D  pParm20                     100a   const options(*nopass:*varsize:*trim)
000364150612     D  pParm21                     100a   const options(*nopass:*varsize:*trim)
000365150612     D  pParm22                     100a   const options(*nopass:*varsize:*trim)
000366150612     D  pParm23                     100a   const options(*nopass:*varsize:*trim)
000367150612     D  pParm24                     100a   const options(*nopass:*varsize:*trim)
000368150612     D  pParm25                     100a   const options(*nopass:*varsize:*trim)
000369150612     D  pParm26                     100a   const options(*nopass:*varsize:*trim)
000370150612     D  pParm27                     100a   const options(*nopass:*varsize:*trim)
000371150612     D  pParm28                     100a   const options(*nopass:*varsize:*trim)
000372150612     D  pParm29                     100a   const options(*nopass:*varsize:*trim)
000373150612     D  pParm30                     100a   const options(*nopass:*varsize:*trim)
000374150612
000375150612     D f_RunOptionSplf...
000376150612     D                 PR
000377150612     D  p_Option                      1a
000378150612     D  p_SplfName                   10a
000379150612     D  p_SplfNum                     6a
000380150612     D  p_JobName                    10a
000381150612     D  p_JobUser                    10a
000382150612     D  p_JobNum                      6a
000383150612     D  p_EmailAddr                  60a
000384150612     D  p_ProgId                     10a
000385150612
000386150612     D f_IsValidObj    PR              n
000387150612     D  p_ObjNam                     10a   const
000388150612     D  p_ObjLib                     10a   const
000389150612     D  p_ObjTyp                     10a   const
000390150612
000391150612     D f_Qusrobjd      PR           480a
000392150612     D  p_ObjQual                    20a   const
000393150612     D  p_ObjTyp                     10a   const
000394150612     D  p_ApiFormat                   8a   const options(*nopass)
000395150612
000396150612     D f_RtvMsgAPI     PR           232a
000397150612     D  p_ErrMsgID                    7a   const
000398150612     D  p_MsgReplace                112a
000399150612     D  p_MsgFileQual                20a   const options(*nopass)
000400150612
000401150612     D f_SndSflMsg     PR
000402150612     D  p_ProgName                   10a   const
000403150612     D  p_MsgTxt                     75a   const
000404150612     D  p_MsgID                       7a   const   options(*nopass)
000405150612     D  p_MsgFile                    10a   const   options(*nopass)
000406150612     D  p_MsgLib                     10a   const   options(*nopass)
000407150612
000408150612     D f_System        PR                  opdesc
000409150612     D  p_String                   2048a   const options(*varsize)
000410150612
000411150601       //---------------------------------------------------------
000412150601       // DS of spooled file attributes return variable.
000413150601     D splf0300DS      DS                  qualified based(splf0300Ptr)
000414150601     D  JobName                      10a   overlay(splf0300DS:1)
000415150601     D  UserID                       10a   overlay(splf0300DS:11)
000416150601     D  JobNo                         6a   overlay(splf0300DS:21)
000417150601     D  SplfName                     10a   overlay(splf0300DS:27)
000418150601     D  SplfNum                      10i 0 overlay(splf0300DS:37)
000419150601     D  Status                       10i 0 overlay(splf0300DS:41)
000420150601     D  CreateYYMMDD                  6a   overlay(splf0300DS:46)
000421150601     D  CreateHHMMSS                  6a   overlay(splf0300DS:52)
000422150601     D  UsrDta                       10a   overlay(splf0300DS:69)
000423150601     D  FormType                     10a   overlay(splf0300DS:79)
000424150601     D  Outq                         10a   overlay(splf0300DS:89)
000425150601     D  OutqLib                      10a   overlay(splf0300DS:99)
000426150601     D  ASP                          10i 0 overlay(splf0300DS:109)
000427150601     D  SplfSize                     10i 0 overlay(splf0300DS:113)
000428150601     D  MultiplySize                 10i 0 overlay(splf0300DS:117)
000429150601     D  PageNum                      10i 0 overlay(splf0300DS:121)
000430150601     D  Copies                       10i 0 overlay(splf0300DS:125)
000431150601     D  Priority                      1a   overlay(splf0300DS:129)
000432150601
000433150603     D SpoolAlpha      DS                  Inz
000434150603     D   scSplno                      6s 0
000435150601
000436150603     D aOptions        ds                                                       control no display
000437150603     D aOptions1                           overlay(aOptions:1)
000438150603     D aOptions2                           overlay(aOptions:1)
000439150603     D aOptions3                           overlay(aOptions:1)
000440150603     D aOptions4                           overlay(aOptions:1)
000441150603
000442150601
000443150601      //--*ENTRY PARMS-------------------------------------------
000444150607     D p_JCRSPLFR      PR                  extpgm('PDFSPLFR')
000445150603     D                               10a
000446150603     D                               10a
000447150603     D                               20a
000448150603     D                               10a
000449150603     D                               10a
000450150603     D p_JCRSPLFR      PI
000451150603     D  p_SplfName                   10a
000452150603     D  p_UsrDta                     10a
000453150603     D  p_OutqQual                   20a
000454150603     D  p_Usrprf                     10a
000455150603     D  p_Formtyp                    10a
000456150603
000457150601      //---------------------------------------------------------
000458150603      /free
000459150601       evalr scDow = %trimr(f_GetDayName());
000460150601
000461150601 1b    if %subst(p_OutqQual: 1: 4) = '*ALL';
000462150601          p_OutqQual = '*ALL ';
000463150601 1e    endif;
000464150601
000465150601       // If generic spooled file name, get length of non-generic name
000466150601       aa = %scan('*':p_SplfName);
000467150601
000468150601       // create user space.
000469150601       GenericHeaderPtr = f_Quscrtus(UserSpaceName);
000470150601
000471150601       // line up option headings depending on your system
000472150601       IsSndSplf = f_IsValidObj('SNDSPLF   ': '*LIBL     ': '*CMD');
000473150601       IsEsend =   f_IsValidObj('ESNDMAIL  ': 'ESEND     ': '*CMD');
000474150601 1b    if IsSndSplf and IsEsend;
000475150601          scOptions = oE + oS + o2 + o3 + o4 + o5;
000476150601 1x    elseif IsESend;
000477150601          scOptions = oE + o2 +'  '+ o3 + o4 + '  ' +o5;
000478150601 1x    elseif IsSndSplf;
000479150601          scOptions = oS + '  '+ o2 +'  '+ o3 + o4 + o5;
000480150601 1x    else;
000481150601          scOptions = o2 +'   '+ o3 + ' '+ o4 + o5;
000482150601 1e    endif;
000483150601
000484150601       //---------------------------------------------------------
000485150601       // Set looping subroutine so user can refresh screen
000486150601 1b    dou  IsExitPgm;
000487150601          exsr srRefreshScreen;
000488150601 1e    enddo;
000489150601       *inlr = *on;
000490150601       return;
000491150601
000492150601       //---------------------------------------------------------
000493150601       // call API to load user space with spooled file attributes.
000494150601       begsr srRefreshScreen;
000495150601       callp QUSLSPL(
000496150601             UserSpaceName:
000497150601             'SPLF0300':
000498150601             p_Usrprf:
000499150601             p_OutqQual:
000500150601             p_Formtyp:
000501150601             p_UsrDta:
000502150601             ApiErrDS);
000503150601
000504150601       //---------------------------------------------------------
000505150601       // Move through user space to get spooled file attributes.
000506150601       splf0300Ptr = GenericHeaderPtr + GenericHeader.OffSetToList;
000507150601 1b    for ForCount = 1 to GenericHeader.ListEntryCount;
000508150601 2b       if p_SplfName = '*ALL     '
000509150601             or p_SplfName = splf0300DS.SplfName
000510150601             or (aa>0 and
000511150601             %subst(p_SplfName:1:aa-1) =
000512150601             %subst(splf0300DS.SplfName: 1: aa-1));
000513150601 3b          if splf0300DS.Status = 1;
000514150601                scStatus = 'RDY';
000515150601 3x          elseif splf0300DS.Status = 2;
000516150601                scStatus = 'OPN';
000517150601 3x          elseif splf0300DS.Status = 3;
000518150601                scStatus = 'CLO';
000519150601 3x          elseif splf0300DS.Status = 4;
000520150601                scStatus = 'SAV';
000521150601 3x          elseif splf0300DS.Status = 5;
000522150601                scStatus = 'WTR';
000523150601 3x          elseif splf0300DS.Status = 6;
000524150601                scStatus = 'HLD';
000525150601 3x          elseif splf0300DS.Status = 7;
000526150601                scStatus = 'MSGW';
000527150601 3x          elseif splf0300DS.Status = 8;
000528150601                scStatus = 'PND';
000529150601 3x          elseif splf0300DS.Status = 9;
000530150601                scStatus = 'PRT';
000531150601 3x          elseif splf0300DS.Status = 10;
000532150601                scStatus = 'FIN';
000533150601 3x          elseif splf0300DS.Status = 11;
000534150601                scStatus = 'SND';
000535150601 3x          elseif splf0300DS.Status = 12;
000536150601                scStatus = 'DFR';
000537150601 3e          endif;
000538150601             scSplfName = splf0300DS.SplfName;
000539150601             scNumPages = splf0300DS.PageNum;
000540150601             scCurPage = 0;
000541150601             scCopies = splf0300DS.Copies;
000542150601             scPriority = splf0300DS.Priority;
000543150601             scOutq = splf0300DS.Outq;
000544150601             scOutqLib = splf0300DS.OutqLib;
000545150601             scSplno = splf0300DS.SplfNum;
000546150601             scJobName = splf0300DS.JobName;
000547150601             scUserID = splf0300DS.UserID;
000548150601             scJobNo = splf0300DS.JobNo;
000549150601             scFormType = splf0300DS.FormType;
000550150601             scUsrDta = splf0300DS.UsrDta;
000551150601             scSplfDate = %Char(%Date(splf0300DS.CreateYYMMDD:*YMD0):*MDY/);
000552150601             scLastUsed = scSplfDate;
000553150601             scSplfTime = %Char(%time(splf0300DS.CreateHHMMSS: *HMS0));
000554150601             scASP = splf0300DS.ASP;
000555150601             scFileSize =
000556150601             (splf0300DS.SplfSize * splf0300DS.MultiplySize) / 1024;
000557150601             clear sbfOption;
000558150601             rrn += 1;
000559150601
000560150601 3b          if rrn = 9999;
000561150601 1v             leave;
000562150601 3e          endif;
000563150601
000564150601             write SBFDTA1;
000565150601             write SBFDTA2;
000566150601             write SBFDTA3;
000567150601             write SBFDTA4;
000568150601 2e       endif;
000569150601          splf0300Ptr += GenericHeader.ListEntrySize;
000570150601 1e    endfor;
000571150601       Lastrrn = rrn;
000572150601
000573150601       //---------------------------------------------------------
000574150601       // allow user to make selection from subfile.
000575150601       NextView = 2;
000576150601       SflRcdNbr = 1;
000577150601       Ind.sfldsp = (rrn > 0);
000578150601 1b    if not Ind.sfldsp;
000579150601          f_SndSflMsg(ProgId: 'No spooled files match your selections.');
000580150601 1e    endif;
000581150601       Ind.sfldspctl = *on;
000582150601
000583150601       //---------------------------------------------------------
000584150601 1b    if IsRefresh and Ind.sfldsp;
000585150601 2b       if SflRcdNbrSav > rrn;
000586150601             SflRcdNbr = rrn;
000587150601 2x       else;
000588150601 3b          if SflRcdNbrSav = 0;
000589150601                SflRcdNbr = 1;
000590150601 3x          else;
000591150601                SflRcdNbr = SflRcdNbrSav;
000592150601 3e          endif;
000593150601 2e       endif;
000594150601          NextView = NextViewSav;
000595150601          IsRefresh = *off;
000596150601 1e    endif;
000597150601
000598150601       //---------------------------------------------------------
000599150601 1b    dow not (InfdsFkey = f03);
000600150601 2b       if InfdsFkey = f11;  //CHANGE VIEW
000601150601             NextView += 1;
000602150601 3b          if NextView > 4;
000603150601                NextView = 1;
000604150601 3e          endif;
000605150601 2e       endif;
000606150601          write MSGCTL;
000607150601          write SHEADER;
000608150601          write SFOOTER1;
000609150601
000610150601          //---------------------------------------------------------
000611150601          // display various views 1-4.
000612150601          IsView1 = *off;
000613150601          IsView2 = *off;
000614150601          IsView3 = *off;
000615150601          IsView4 = *off;
000616150601 2b       if NextView = 2;
000617150601             exfmt SBFCTL1;
000618150601             IsView1 = *on;
000619150601 2x       elseif NextView = 3;
000620150601             exfmt SBFCTL2;
000621150601             IsView2 = *on;
000622150601 2x       elseif NextView = 4;
000623150601             exfmt SBFCTL3;
000624150601             IsView3 = *on;
000625150601 2x       elseif NextView = 1;
000626150601             exfmt SBFCTL4;
000627150601             IsView4 = *on;
000628150601 2e       endif;
000629150601
000630150601 2b       if InfdsFkey = f03
000631150601             or InfdsFkey = f12;
000632150601             IsExitPgm = *on;
000633150601 LV          leavesr;
000634150601 2e       endif;
000635150601
000636150601          f_RmvSflMsg(ProgId);
000637150601          // refresh
000638150601          SflRcdNbr = SflRecNbr;
000639150601 2b       if InfdsFkey = f05;
000640150601             IsRefresh = *on;
000641150601             SflRcdNbrSav = SflRcdNbr;
000642150601             NextViewsav = NextView;
000643150601             Ind.sfldsp = *off;
000644150601             Ind.sfldspctl = *off;
000645150601             aOptions = %bitor(Green:UL);
000646150601             Ind.sflnxtchg = *off;
000647150601             write SBFCTL1;
000648150601             write SBFCTL2;
000649150601             write SBFCTL3;
000650150601             write SBFCTL4;
000651150601             rrn = 0;
000652150601 LV          leavesr;
000653150601 2e       endif;
000654150601          // no records
000655150601 2b       if not Ind.sfldsp;
000656150601 1i          iter;
000657150601 2e       endif;
000658150601
000659150601          // process user requests
000660150601 2b       if IsView1;
000661150601             readc SBFDTA1;
000662150601 2x       elseif IsView2;
000663150601             readc SBFDTA2;
000664150601 2x       elseif IsView3;
000665150601             readc SBFDTA3;
000666150601 2x       elseif IsView4;
000667150601             readc SBFDTA4;
000668150601 2e       endif;
000669150601 2b       dow not %eof;
000670150601 3b          if sbfOption > ' ';
000671150601                IsOption4 = (sbfOption = '4');
000672150601                //---------------------------------------------------------
000673150601 4b             if InfdsFkey = f13;
000674150601                   exsr srRepeat_Option;
000675150601 2v                leave;
000676150601 4x             else;
000677150601                   f_RunOptionSplf(
000678150601                   sbfOption:
000679150601                   scSplfName :
000680150601                   SpoolAlpha:
000681150601                   scJobName :
000682150601                   scUserID :
000683150601                   scJobNo:
000684150601                   EmailAddr:
000685150601                   ProgId);
000686150601
000687150601                   // update subfile to reflect selected change.
000688150601                   aOptions = %bitor(Green:UL);
000689150601 5b                if sbfOption = '3';
000690150601                      scStatus = 'HLD';
000691150601 5x                elseif sbfOption = '6';
000692150601                      scStatus = 'RLS';
000693150601 5e                endif;
000694150601                   clear sbfOption;
000695150601
000696150601 5b                if IsView1;
000697150601                      update SBFDTA1;
000698150601 5x                elseif IsView2;
000699150601                      update SBFDTA2;
000700150601 5x                elseif IsView3;
000701150601                      update SBFDTA3;
000702150601 5x                elseif IsView4;
000703150601                      update SBFDTA4;
000704150601 5e                endif;
000705150601
000706150601                   // If spooled file is deleted, flag it as deleted  in all views.
000707150601 5b                if IsOption4;
000708150601                      chain rrn SBFDTA1;
000709150601                      clear SBFDTA1;
000710150601                      scSplfName = '*deleted';
000711150601                      aOptions = ND;
000712150601                      update SBFDTA1;
000713150601
000714150601                      chain rrn SBFDTA2;
000715150601                      clear SBFDTA2;
000716150601                      scSplfName = '*deleted';
000717150601                      aOptions = ND;
000718150601                      update SBFDTA2;
000719150601
000720150601                      chain rrn SBFDTA3;
000721150601                      clear SBFDTA3;
000722150601                      scSplfName = '*deleted';
000723150601                      aOptions = ND;
000724150601                      update SBFDTA3;
000725150601
000726150601                      chain rrn SBFDTA4;
000727150601                      clear SBFDTA4;
000728150601                      scSplfName = '*deleted';
000729150601                      aOptions = ND;
000730150601                      update SBFDTA4;
000731150601 5e                endif;
000732150601                   SflRcdNbr = rrn;
000733150601 4e             endif;
000734150601 3e          endif;
000735150601
000736150601 3b          if IsView1;
000737150601                readc SBFDTA1;
000738150601 3x          elseif IsView2;
000739150601                readc SBFDTA2;
000740150601 3x          elseif IsView3;
000741150601                readc SBFDTA3;
000742150601 3x          elseif IsView4;
000743150601                readc SBFDTA4;
000744150601 3e          endif;
000745150601 2e       enddo;
000746150601 1e    enddo;
000747150601       endsr;
000748150601
000749150601       //---------------------------------------------------------
000750150601       // Idea is to make 'repeat' option work same way
000751150601       // it does in PDM. User can select option, then press
000752150601       // f13 to have it repeat to end of subfile.
000753150601       //---------------------------------------------------------
000754150601       begsr srRepeat_Option;
000755150601       SflRcdNbr = rrn;
000756150601       OptionSav = sbfOption;
000757150601 1b    for rrnx = SflRcdNbr to LastRrn;
000758150601 2b       if IsView1;
000759150601             chain rrnx SBFDTA1;
000760150601 2x       elseif IsView2;
000761150601             chain rrnx SBFDTA2;
000762150601 2x       elseif IsView3;
000763150601             chain rrnx SBFDTA3;
000764150601 2x       elseif IsView4;
000765150601             chain rrnx SBFDTA4;
000766150601 2e       endif;
000767150601
000768150601 2b       if not %found;
000769150601 1v          leave;
000770150601 2e       endif;
000771150601          Ind.sflnxtchg = *on;
000772150601          sbfOption = OptionSav;
000773150601
000774150601 2b       if IsView1;
000775150601             update SBFDTA1;
000776150601 2x       elseif IsView2;
000777150601             update SBFDTA2;
000778150601 2x       elseif IsView3;
000779150601             update SBFDTA3;
000780150601 2x       elseif IsView4;
000781150601             update SBFDTA4;
000782150601 2e       endif;
000783150601 1e    endfor;
000784150601       Ind.sflnxtchg = *off;
000785150601       endsr;
000786150603      /end-free
000787150601       //---------------------------------------------------------
000788150601       // Remove all messages from error message subfile
000789150601     P f_RmvSflMsg     B                   export
000790150601     D f_RmvSflMsg     PI
000791150601     D  p_ProgName                   10a   const
000792150601     D Qmhrmvpm        PR                  ExtPgm('QMHRMVPM')
000793150601     D                               10a   const
000794150601     D                               10i 0 const
000795150601     D                                4a   const
000796150601     D                               10a   const
000797150601     Ds                                    like(ApiErrDS)
000798150601
000799150610      /free
000800150601       callp Qmhrmvpm(
000801150601             p_ProgName:
000802150601             0:
000803150601             '   ':
000804150601             '*ALL':
000805150601             ApiErrDs);
000806150601       return;
000807150610      /end-free
000808150601     P f_RmvSflMsg...
000809150601     P                 E
000810150601       //---------------------------------------------------------
000811150601       // Accepts ISO real date field and returns integer value representing offset from
000812150601       // Saturday. 1=Sunday, 2 = Monday, etc...
000813150603     P f_DayOfWeekNumber...
000814150603     P                 B                   export
000815150603     D f_DayOfWeekNumber...
000816150603     D                 PI             3u 0                                      Day Of Week
000817150603     D  p_DateISO                      d    const
000818150603
000819150603     D DayOfWeek       s              3u 0
000820150603     D ceedays         PR                  extproc('CEEDAYS') OpDesc            day of week lilian
000821150603     D                                8a   const                                iso
000822150603     D                                8a   const                                Picture
000823150603     D                               10i 0                                      lilian date
000824150603     D                               12a   const options(*omit)                 feedback
000825150603
000826150603     D ceedywk         PR                  extproc('CEEDYWK')                   day of week lilian
000827150603     D                               10i 0                                      lilian date
000828150603     D                               10i 0                                      D O W number
000829150603     D                               12a   const options(*omit)                 feedback
000830150603
000831150603     D Pic             s              8a   inz('YYYYMMDD')
000832150603     D Lilian          s             10i 0
000833150603     D xx              s             10i 0
000834150603     D FeedBack        s             12a
000835150610      /free
000836150601        ApiErrDS.BytesReturned = 0;   //default error handler
000837150601
000838150601        callp ceedays(%char(p_DateISO:*iso0): Pic: Lilian: *OMIT);
000839150601        callp ceedywk(Lilian: xx: *OMIT);
000840150601
000841150601        DayOfWeek = xx;
000842150601        return DayOfWeek;
000843150610      /end-free
000844150603     P                 E
000845150601
000846150601       //---------------------------------------------------------
000847150601       // Accepts ISO real date field and returns day name. If no date is passed,
000848150601       // function will return name of today date.
000849150603
000850150603     P f_GetDayName    B                   export
000851150603     D f_GetDayName    PI             9a                                        Day Name
000852150603     D  p_DateISO                      d   Const options(*NoPass)               ISO Date
000853150603     D xx              s              3u 0
000854150610      /free
000855150601        ApiErrDS.BytesReturned = 0;
000856150601
000857150601 1b     if %parms = 0;
000858150601           xx = f_DayOfWeekNumber(%date());
000859150601 1x     else;
000860150601           xx = f_DayOfWeekNumber(p_DateISO);
000861150601 1e     endif;
000862150601
000863150601 1b     if xx = 1;
000864150601           return 'Sunday   ';
000865150601 1x     elseif xx = 2;
000866150601           return 'Monday   ';
000867150601 1x     elseif xx = 3;
000868150601           return 'Tuesday  ';
000869150601 1x     elseif xx = 4;
000870150601           return 'Wednesday';
000871150601 1x     elseif xx = 5;
000872150601           return 'Thursday ';
000873150601 1x     elseif xx = 6;
000874150601           return 'Friday   ';
000875150601 1x     elseif xx = 7;
000876150601           return 'Saturday ';
000877150601 1x     else;
000878150601           ApiErrDS.BytesReturned = 20;
000879150601           ApiErrDS.ErrMsgId = 'CPD5118';
000880150601           ApiErrDS.MsgReplaceVal = *blanks;
000881150603 1e     endif;
000882150610      /end-free
000883150603     P f_GetDayName    E
000884150601
000885150601       //---------------------------------------------------------
000886150601       // Create user space, change attributes to allow automatic extendibility,
000887150601       // and return pointer to user space.
000888150603     P f_Quscrtus      B                   export
000889150603     D f_Quscrtus      PI              *
000890150603     D  p_UserSpace                  20a
000891150603     D uPtr            s               *
000892150603     D ReturnLib       s             10a
000893150603
000894150601
000895150601     D Quscrtus        PR                  extpgm('QUSCRTUS')                   create user space
000896150601     D                               20a                                        user space
000897150601     D                               10a   const                                extended attribute
000898150601     D                               10i 0 const                                length of space
000899150601     D                                1a   const                                hex0 initialize
000900150601     D                               10a   const                                use authority
000901150601     D                               50a   const                                text
000902150601     D                               10a   const                                replace object
000903150601     Db                                    like(ApiErrDS)
000904150601     D                               10a   const                                domain
000905150601     D                               10i 0 const                                transfer size
000906150601     D                                1a   const                                optimum space
000907150601
000908150601     D Quscusat        PR                  extpgm('QUSCUSAT')                   change space attrib
000909150601     D                               10a                                        return library
000910150601     D                               20a                                        user space
000911150601     Db                                    like(QuscusatDS)                     key to change
000912150601     Db                                    like(ApiErrDS)
000913150601
000914150601     D QuscusatDS      DS                  qualified
000915150601     D  NumberRecs                   10i 0 overlay(QuscusatDS:1) inz(2)
000916150601     D  Key1                         10i 0 overlay(QuscusatDS:5) inz(2)         Initial Value
000917150601     D  LengthOfData1                10i 0 overlay(QuscusatDS:9) inz(1)
000918150601     D  Data1                         1a   overlay(QuscusatDS:13) inz(x'00')
000919150601     D  Key2                         10i 0 overlay(QuscusatDS:14) inz(3)        Auto Extend
000920150601     D  LengthOfData2                10i 0 overlay(QuscusatDS:18) inz(1)
000921150601     D  Data2                         1a   overlay(QuscusatDS:22) inz('1')
000922150601
000923150601     D Qusptrus        PR                  extpgm('QUSPTRUS')                   retrieve pointer
000924150601     D                               20a                                        user space
000925150601     D                                 *                                        pointer
000926150601     Db                                    like(ApiErrDS)
000927150601
000928150610      /free
000929150601        callp QUSCRTUS(
000930150601              p_UserSpace:
000931150601              'PDFCMDS':
000932150601              8192:
000933150601              x'00':
000934150601              '*ALL':
000935150601              'User Space PDFCMDS ':
000936150601              '*NO':
000937150601              ApiErrDS:
000938150601              '*DEFAULT':
000939150601              32:
000940150601              '1');
000941150601        callp QUSCUSAT(
000942150601              ReturnLib:
000943150601              p_UserSpace:
000944150601              QuscusatDS:
000945150601              ApiErrDS);
000946150601        callp QUSPTRUS(
000947150601              p_UserSpace:
000948150601              uPtr:
000949150601              ApiErrDS );
000950150601        return uPtr;
000951150610      /end-free
000952150603     P f_Quscrtus      E
000953150601
000954150601       //---------------------------------------------------------
000955150601       // Returns string with replacement values loaded from parms. Accepts base string with
000956150601       // replacement values noted by & sign then accepts parms to replace & characters.
000957150601       // Special value &q is arbitrarily used to signify single Quote. You can check
000958150601       // ApiErrDs data structure if your string was returned as error.
000959150601       // NOTE:  all character strings passed to this function should be %TRIMR( )
000960150601       //---------------------------------------------------------
000961150603     P f_BuildString   B                   export
000962150603     D f_BuildString   PI          2048a   opdesc
000963150607     D  pString                    2048a   const options(*varsize)
000964150607     D  pParm01                     100a   const options(*nopass:*varsize:*trim)
000965150607     D  pParm02                     100a   const options(*nopass:*varsize:*trim)
000966150607     D  pParm03                     100a   const options(*nopass:*varsize:*trim)
000967150607     D  pParm04                     100a   const options(*nopass:*varsize:*trim)
000968150607     D  pParm05                     100a   const options(*nopass:*varsize:*trim)
000969150607     D  pParm06                     100a   const options(*nopass:*varsize:*trim)
000970150607     D  pParm07                     100a   const options(*nopass:*varsize:*trim)
000971150607     D  pParm08                     100a   const options(*nopass:*varsize:*trim)
000972150607     D  pParm09                     100a   const options(*nopass:*varsize:*trim)
000973150607     D  pParm10                     100a   const options(*nopass:*varsize:*trim)
000974150607     D  pParm11                     100a   const options(*nopass:*varsize:*trim)
000975150607     D  pParm12                     100a   const options(*nopass:*varsize:*trim)
000976150607     D  pParm13                     100a   const options(*nopass:*varsize:*trim)
000977150607     D  pParm14                     100a   const options(*nopass:*varsize:*trim)
000978150607     D  pParm15                     100a   const options(*nopass:*varsize:*trim)
000979150607     D  pParm16                     100a   const options(*nopass:*varsize:*trim)
000980150607     D  pParm17                     100a   const options(*nopass:*varsize:*trim)
000981150607     D  pParm18                     100a   const options(*nopass:*varsize:*trim)
000982150607     D  pParm19                     100a   const options(*nopass:*varsize:*trim)
000983150607     D  pParm20                     100a   const options(*nopass:*varsize:*trim)
000984150607     D  pParm21                     100a   const options(*nopass:*varsize:*trim)
000985150607     D  pParm22                     100a   const options(*nopass:*varsize:*trim)
000986150607     D  pParm23                     100a   const options(*nopass:*varsize:*trim)
000987150607     D  pParm24                     100a   const options(*nopass:*varsize:*trim)
000988150607     D  pParm25                     100a   const options(*nopass:*varsize:*trim)
000989150607     D  pParm26                     100a   const options(*nopass:*varsize:*trim)
000990150607     D  pParm27                     100a   const options(*nopass:*varsize:*trim)
000991150607     D  pParm28                     100a   const options(*nopass:*varsize:*trim)
000992150607     D  pParm29                     100a   const options(*nopass:*varsize:*trim)
000993150607     D  pParm30                     100a   const options(*nopass:*varsize:*trim)
000994150607
000995150603     D xx              s              3u 0
000996150603     D QuoteCount      s              5i 0
000997150603     D ParmCount       s              5i 0
000998150603     D cc              s              5u 0
000999150603     D String          s           2048a
001000150603     D ParmArry        s            100a   dim(30)
001001150607     D ReplaceCount    s              3u 0
001002150601
001003150610      /free
001004150610
001005150601        ApiErrDS.BytesReturned = 0;   //default error handler
001006150601        String = %trimr(pString);
001007150612
001008150612       // make Quotes uppercase for remainder of function
001009150612       cc = %scan('&q': String);
001010150612 1b    dow cc > 0;
001011150612          %subst(String:cc:2) = '&Q';
001012150612          cc = %scan('&q': String: cc + 1);
001013150612 1e    enddo;
001014150612
001015150612       // Spin through and replace all single Quotes.
001016150612       cc = %scan('&Q': String);
001017150612 1b    dow cc > 0;
001018150612          String = %replace(qs: String: cc: 2);
001019150612          cc = %scan('&Q': String: cc + 1);
001020150612 1e    enddo;
001021150612
001022150612       // better way of replacing quotes if we could compile to V7
001023150612       //  String = %scanrpl('&q':qs: String);
001024150612       // String = %scanrpl('&Q':qs: String);
001025150601
001026150601       // Load replacement value parms into array
001027150601       // so it will be easier to process in the next step.
001028150601        ReplaceCount = %parms - 1;
001029150601 1b     if ReplaceCount >= 1;
001030150601           ParmArry(1) = pParm01;
001031150601 1e     endif;
001032150601 1b     if ReplaceCount >= 2;
001033150601           ParmArry(2) = pParm02;
001034150601 1e     endif;
001035150601 1b     if ReplaceCount >= 3;
001036150601           ParmArry(3) = pParm03;
001037150601 1e     endif;
001038150601 1b     if ReplaceCount >= 4;
001039150601           ParmArry(4) = pParm04;
001040150601 1e     endif;
001041150601 1b     if ReplaceCount >= 5;
001042150601           ParmArry(5) = pParm05;
001043150601 1e     endif;
001044150601 1b     if ReplaceCount >= 6;
001045150601           ParmArry(6) = pParm06;
001046150601 1e     endif;
001047150601 1b     if ReplaceCount >= 7;
001048150601           ParmArry(7) = pParm07;
001049150601 1e     endif;
001050150601 1b     if ReplaceCount >= 8;
001051150601           ParmArry(8) = pParm08;
001052150601 1e     endif;
001053150601 1b     if ReplaceCount >= 9;
001054150601           ParmArry(9) = pParm09;
001055150601 1e     endif;
001056150601 1b     if ReplaceCount >= 10;
001057150601           ParmArry(10) = pParm10;
001058150601 1e     endif;
001059150601 1b     if ReplaceCount >= 11;
001060150601           ParmArry(11) = pParm11;
001061150601 1e     endif;
001062150601 1b     if ReplaceCount >= 12;
001063150601           ParmArry(12) = pParm12;
001064150601 1e     endif;
001065150601 1b     if ReplaceCount >= 13;
001066150601           ParmArry(13) = pParm13;
001067150601 1e     endif;
001068150601 1b     if ReplaceCount >= 14;
001069150601           ParmArry(14) = pParm14;
001070150601 1e     endif;
001071150601 1b     if ReplaceCount >= 15;
001072150601           ParmArry(15) = pParm15;
001073150601 1e     endif;
001074150601 1b     if ReplaceCount >= 16;
001075150601           ParmArry(16) = pParm16;
001076150601 1e     endif;
001077150601 1b     if ReplaceCount >= 17;
001078150601           ParmArry(17) = pParm17;
001079150601 1e     endif;
001080150601 1b     if ReplaceCount >= 18;
001081150601           ParmArry(18) = pParm18;
001082150601 1e     endif;
001083150601 1b     if ReplaceCount >= 19;
001084150601           ParmArry(19) = pParm19;
001085150601 1e     endif;
001086150601 1b     if ReplaceCount >= 20;
001087150601           ParmArry(20) = pParm20;
001088150601 1e     endif;
001089150601 1b     if ReplaceCount >= 21;
001090150601           ParmArry(21) = pParm21;
001091150601 1e     endif;
001092150601 1b     if ReplaceCount >= 22;
001093150601           ParmArry(22) = pParm22;
001094150601 1e     endif;
001095150601 1b     if ReplaceCount >= 23;
001096150601           ParmArry(23) = pParm23;
001097150601 1e     endif;
001098150601 1b     if ReplaceCount >= 24;
001099150601           ParmArry(24) = pParm24;
001100150601 1e     endif;
001101150601 1b     if ReplaceCount >= 25;
001102150601           ParmArry(25) = pParm25;
001103150601 1e     endif;
001104150601 1b     if ReplaceCount >= 26;
001105150601           ParmArry(26) = pParm26;
001106150601 1e     endif;
001107150601 1b     if ReplaceCount >= 27;
001108150601           ParmArry(27) = pParm27;
001109150601 1e     endif;
001110150601 1b     if ReplaceCount >= 28;
001111150601           ParmArry(28) = pParm28;
001112150601 1e     endif;
001113150601 1b     if ReplaceCount >= 29;
001114150601           ParmArry(29) = pParm29;
001115150601 1e     endif;
001116150601 1b     if ReplaceCount = 30;
001117150601           ParmArry(30) = pParm30;
001118150601 1e     endif;
001119150601
001120150601       //---------------------------------------------------------
001121150601       // Load all replacement values into string.
001122150601       // use ceegsi to get actual length of parms.
001123150601       //---------------------------------------------------------
001124150601        cc = %scan('&': String);
001125150601 1b     for xx = 1 to ReplaceCount;
001126150601           CEEGSI(xx + 1: DataType: ParmLen: MaxLen: *omit);
001127150601           String=%replace(%subst(ParmArry(xx):1:ParmLen): String: cc: 1);
001128150601
001129150601          // avoid cc being past length of varchar;
001130150601 2b        if xx <  ReplaceCount;
001131150601 3b           monitor;
001132150601                 cc = %scan('&': String: cc + ParmLen);
001133150601 3x           on-error;
001134150601                 String = 'Too many replacement values specified.';
001135150601 3v              leave;
001136150601 3e           endmon;
001137150601 2e        endif;
001138150601
001139150601 1e     endfor;
001140150601
001141150601        return String;
001142150610      /end-free
001143150603     P f_BuildString   E
001144150601
001145150601       //---------------------------------------------------------
001146150601       // Execute system command depending on option selected.
001147150601     P f_RunOptionSplf...
001148150601     P                 B                   export
001149150601     D f_RunOptionSplf...
001150150601     D                 PI
001151150601     D  p_Option                      1a
001152150601     D  p_SplfName                   10a
001153150601     D  p_SplfNum                     6a
001154150601     D  p_JobName                    10a
001155150601     D  p_JobUser                    10a
001156150601     D  p_JobNum                      6a
001157150601     D  p_EmailAddr                  60a
001158150601     D  p_ProgId                     10a
001159150601
001160150603     D Msg             s             75a
001161150603     D SpoolString     s            120a   Varying
001162150601
001163150601     D Alpha6          ds                  qualified
001164150601     D num6                           6s 0 inz(0)
001165150601
001166150601     D p_PDFEADDR      PR                  extpgm('PDFEADDR')                   one time email setup
001167150601     D                               60a                                        or get email address
001168150601     D p_PDFSPLFR2     PR                  extpgm('PDFSPLFR2')
001169150601     D                               10a                                        Job Name
001170150601     D                               10a                                        User Name
001171150601     D                                6a                                        Job Number
001172150601     D                               10a                                        Spooled File Name
001173150601     D                                6s 0                                      Spooled File Number
001174150601
001175150610      /free
001176150601       // get or setup default email one time
001177150601 1b    if p_Option = 'E' or p_Option = 'S';
001178150601          callp p_PDFEADDR(EmailAddr);
001179150601 1e    endif;
001180150601
001181150601 1b    if p_Option = 'S';
001182150601          SpoolString = %trimr(f_BuildString
001183150601          ('SPLF(&) JOB(&/&/&) SPLFN(&)':
001184150601          p_SplfName: p_JobNum: p_JobUser: p_JobName: p_SplfNum));
001185150601
001186150601 1x    elseif p_Option = 'E';
001187150601          SpoolString = %trimr(f_BuildString
001188150601          ('RECIPIENT(&) ATTLIST((* *PDF *N & &/&/& &))':
001189150601          EmailAddr: p_SplfName: p_JobNum:
001190150601          p_JobUser: p_JobName:  p_SplfNum));
001191150601
001192150601 1x    else;
001193150601          SpoolString = %trimr(f_BuildString
001194150601          ('FILE(&) JOB(&/&/&) SPLNBR(&)':
001195150601          p_SplfName: p_JobNum: p_JobUser: p_JobName: p_SplfNum));
001196150601 1e    endif;
001197150601
001198150601       //-------------------------------
001199150601 1b    if p_Option = '1';
001200150601          f_System('?SNDNETSPLF ' + SpoolString + ' ??TOUSRID(( ))');
001201150601 2b       if ApiErrDS.BytesReturned = 0;
001202150601             msg = 'Sndnetsplf ' + %trimr(p_SplfName) + ' - Completed.';
001203150601 2x       else;
001204150601 3b          if ApiErrDS.ErrMsgId = 'CPF6801';  // no replace value returned
001205150601                ApiErrDS.MsgReplaceVal = 'F3 ';
001206150601 3e          endif;
001207150601
001208150601             msg = %trimr(f_RtvMsgApi(ApiErrDS.ErrMsgId
001209150601                          : ApiErrDS.MsgReplaceVal));
001210150601 2e       endif;
001211150601          f_SndSflMsg(p_ProgId: msg);
001212150601
001213150601 1x    elseif p_Option = 'S';
001214150601          f_System('?SNDSPLF ' + SpoolString +
001215150601          ' ??TOLIST(' + %trimr(p_EmailAddr) + ') ' +
001216150601          ' ??FRADR(' + %trimr(p_EmailAddr) + ') ' +
001217150601          ' ??SUBJECT(' + %trimr(p_SplfName) + ') ' +
001218150601          ' ??MSGTXT(' + %trimr(p_SplfName) + ') ' +
001219150601          ' ??TOFMT(*PDF) ??TITLE(' + %trimr(p_SplfName) + ')');
001220150601 2b       if ApiErrDS.BytesReturned = 0;
001221150601             msg = 'Sndsplf ' + %trimr(p_SplfName) + ' - Completed.';
001222150601 2x       else;
001223150601             msg = 'Sndsplf ' + %trimr(p_SplfName) + ' - Canceled.';
001224150601 2e       endif;
001225150601          f_SndSflMsg(p_ProgId: msg);
001226150601
001227150601 1x    elseif p_Option = 'E';
001228150601          f_System('?ESEND/ESNDMAIL ' + SpoolString);
001229150601 2b       if ApiErrDS.BytesReturned = 0;
001230150601             msg = 'Esend ' + %trimr(p_SplfName) + ' - Completed.';
001231150601 2x       else;
001232150601             msg = 'Esend ' + %trimr(p_SplfName) + ' - Canceled.';
001233150601 2e       endif;
001234150601          f_SndSflMsg(p_ProgId: msg);
001235150601
001236150601 1x    elseif p_Option = '2';
001237150601          f_System('?CHGSPLFA ' + SpoolString);
001238150601 2b       if ApiErrDS.BytesReturned = 0;
001239150601             msg = 'Change ' + %trimr(p_SplfName) + ' - Completed.';
001240150601 2x       else;
001241150601             msg = 'Change ' + %trimr(p_SplfName) + ' - Canceled.';
001242150601 2e       endif;
001243150601          f_SndSflMsg(p_ProgId: msg);
001244150601
001245150601 1x    elseif p_Option = '3';
001246150601          f_System('HLDSPLF ' + SpoolString);
001247150601          f_SndSflMsg(p_ProgId: 'Hold Spooled File '
001248150601          + %trimr(p_SplfName) + ' - Completed.');
001249150601
001250150601 1x    elseif p_Option = '4';
001251150601          f_System('DLTSPLF ' + SpoolString);
001252150601          f_SndSflMsg(p_ProgId: 'Delete Spooled File '
001253150601          + %trimr(p_SplfName) + ' - Completed.');
001254150601
001255150601 1x    elseif p_Option = '5';
001256150601          f_System('DSPSPLF ' + SpoolString);
001257150601          f_SndSflMsg(p_ProgId: 'Display Spooled File '
001258150601          + %trimr(p_SplfName) + ' - Completed.');
001259150601
001260150601 1x    elseif p_Option = '6';
001261150601          f_System('RLSSPLF ' + SpoolString);
001262150601          f_SndSflMsg(p_ProgId: 'Release Spooled File '
001263150601          + %trimr(p_SplfName) + ' - Completed.');
001264150601
001265150601 1x    elseif p_Option = '8';
001266150603          f_System('WRKSPLFA ' + SpoolString);
001267150603          f_SndSflMsg(p_ProgId: 'Work Spooled File Attributes '
001268150603          + %trimr(p_SplfName) + ' - Completed.');
001269150601
001270150601 1x    elseif p_Option = '9';
001271150601          f_System('?CPYSPLF ' + SpoolString + ' ??TOFILE(  )');
001272150601 2b       if ApiErrDS.BytesReturned = 0;
001273150601             msg = 'Copy ' + %trimr(p_SplfName) + ' - Completed.';
001274150601 2x       else;
001275150601             msg = 'Copy ' + %trimr(p_SplfName) + ' - Canceled.';
001276150601 2e       endif;
001277150601          f_SndSflMsg(p_ProgId: msg);
001278150601
001279150601 1x    elseif p_Option = 'H';
001280150601          f_System('?SPLF2HTML ' + SpoolString +
001281150601          ' ??TODOC(' + qs + '/kpiReports/' + qs +
001282150601          ') STMFOPT(*REPLACE) FONTSIZE(2)');
001283150601 2b       if ApiErrDS.BytesReturned = 0;
001284150601             msg = 'SPLF2HTML ' + %trimr(p_SplfName) + ' - Completed.';
001285150601 2x       else;
001286150601             msg = 'SPLF2HTML ' + %trimr(p_SplfName) + ' - Canceled.';
001287150601 2e       endif;
001288150601          f_SndSflMsg(p_ProgId: msg);
001289150603
001290150603
001291150603        // Susan Gantner added CRTPDF option
001292150603
001293150603 1x    elseif p_Option = 'P';
001294150603          f_System('?CRTPDF ' + SpoolString );
001295150603 2b       if ApiErrDS.BytesReturned = 0;
001296150603             msg = 'CRTPDF ' + %trimr(p_SplfName) + ' - Completed.';
001297150603 2x       else;
001298150603             msg = 'CRTPDF ' + %trimr(p_SplfName) + ' - Canceled.';
001299150603 2e       endif;
001300150603          f_SndSflMsg(p_ProgId: msg);
001301150601
001302150601 1x    else;
001303150601          f_SndSflMsg(p_ProgId: 'Invalid Option Selected.');
001304150601 1e    endif;
001305150601       return;
001306150610      /end-free
001307150601     P f_RunOptionSplf...
001308150601     P                 E
001309150601       //---------------------------------------------------------
001310150601       // If object exists return *on;
001311150601     P f_IsValidObj    B                   export
001312150601     D f_IsValidObj    PI              n
001313150601     D  p_ObjNam                     10a   const
001314150601     D  p_ObjLib                     10a   const
001315150601     D  p_ObjTyp                     10a   const
001316150601
001317150612      /Free
001318150601       f_QUSROBJD(p_ObjNam + p_ObjLib: p_ObjTyp: 'OBJD0100');
001319150601       return (ApiErrDS.BytesReturned = 0);
001320150612      /end-free
001321150601     P f_IsValidObj...
001322150601     P                 E
001323150601
001324150601       //---------------------------------------------------------
001325150601       // Execute Qusrobjd API, included in copy is DS to extract values.
001326150601       // If format not passed, OBJD0200 is used as default.
001327150601     P f_Qusrobjd      B                   export
001328150601     D f_Qusrobjd      PI           480a
001329150601     D  p_ObjQual                    20a   const
001330150601     D  p_ObjTyp                     10a   const
001331150601     D  p_ApiFormat                   8a   const options(*nopass)
001332150601
001333150603     D LocalApiFormat  S              8a
001334150603
001335150601     D Qusrobjd        PR                  extpgm('QUSROBJD')                   object description
001336150601     Db                             472a   options(*varsize)                    receiver
001337150601     D                               10i 0 const                                receiver length
001338150601     D                                8a   const                                api format
001339150601     D                               20a   const                                object and lib
001340150601     D                               10a   const                                object type
001341150601     Db                                    like(ApiErrDS)
001342150601
001343150601     D QusrObjDS       DS                  qualified inz
001344150601     D ObjNam                        10a   overlay(QusrObjDS:9)
001345150601     D Lib                           10a   overlay(QusrObjDS:19)
001346150601     D Type                          10a   overlay(QusrObjDS:29)
001347150601     D ReturnLib                     10a   overlay(QusrObjDS:39)
001348150601     D ExtendedAttr                  10a   overlay(QusrObjDS:91)
001349150601     D CreateDateTime                13a   overlay(QusrObjDS:65)
001350150601     D ChangeDateTime                13a   overlay(QusrObjDS:78)
001351150601     D Text                          50a   overlay(QusrObjDS:101)
001352150601     D SrcFile                       10a   overlay(QusrObjDS:151)
001353150601     D SrcLib                        10a   overlay(QusrObjDS:161)
001354150601     D SrcMbr                        10a   overlay(QusrObjDS:171)
001355150601     D SaveDateTime                  13a   overlay(QusrObjDS:194)
001356150601     DRestoreDateTime                13a   overlay(QusrObjDS:207)
001357150601     D CreatedByUser                 10a   overlay(QusrObjDS:220)
001358150601     D LastUsedDate                   7a   overlay(QusrObjDS:461)               cyymmdd format
001359150601     D NumDaysUsed                   10i 0 overlay(QusrObjDS:469)
001360150601     D ObjSize                       10i 0 overlay(QusrObjDS:473)
001361150601     D MultiplySize                  10i 0 overlay(QusrObjDS:477)
001362150601
001363150610      /free
001364150601 1b    if %parms = 2;
001365150601          LocalApiFormat = 'OBJD0200';
001366150601 1x    else;
001367150601          LocalApiFormat = p_ApiFormat;
001368150601 1e    endif;
001369150601       callp QUSROBJD(
001370150601             QusrobjDS:
001371150601             %len(QusrobjDS):
001372150601             LocalApiFormat:
001373150601             p_ObjQual:
001374150601             p_ObjTyp:
001375150601             ApiErrDS);
001376150601       return QUSROBJDS;
001377150610      /end-free
001378150610
001379150601     P f_Qusrobjd...
001380150601     P                 E
001381150601
001382150601       // Retrieve error message replacement values.
001383150601     P f_RtvMsgAPI     B                   export
001384150601     D f_RtvMsgAPI     PI           232a
001385150601     D  p_ErrMsgID                    7a   const
001386150601     D  p_MsgReplace                112a
001387150601     D  p_MsgFileQual                20a   const options(*nopass)
001388150601
001389150603     D mMsgf           S             20a
001390150603     D mMsgLen         S             10i 0   inz(%len(qmhrtvmds))
001391150601
001392150601     D QmhrtvmDS       DS                   qualified inz
001393150601     D  MessageRtvLen                10i 0  overlay(QmhrtvmDS:9)                length msg retrieved
001394150601     D  MessageRtv                  232a    overlay(QmhrtvmDS:25)               message retrieved
001395150601     D Qmhrtvm         PR                  extpgm('QMHRTVM')                    retrieve messages
001396150601     D                              256a                                        message retrieved
001397150601     D                               10i 0                                      length Of message
001398150601     D                                8a   const                                api format
001399150601     D                                7a   const                                message indentifier
001400150601     D                               20a   const                                msgf and lib
001401150601     D                              100a   const                                replacement data
001402150601     D                               10i 0 const                                replace data length
001403150601     D                               10a   const                                substitution char
001404150601     D                               10a   const                                format control char
001405150601     Db                                    like(ApiErrDS)
001406150601
001407150610      /free
001408150601 1b    if %parms = 2;
001409150601          mMsgf = 'QCPFMSG   *LIBL';
001410150601 2b       if %subst(p_ErrMsgID: 1: 2) = 'RN';
001411150601             mMsgf = 'QRPGLEMSG QDEVTOOLS';
001412150601 2e       endif;
001413150601 1x    else;
001414150601          mMsgf = p_MsgFileQual;
001415150601 1e    endif;
001416150601
001417150601       // need a way to analyze message field data
001418150601       // for now address specific problems as they occur.
001419150601       // CPF0201 Command not created uses &2 and &3, ignores &1
001420150601 1b    if p_ErrMsgid = 'CPF0201';
001421150601          p_MsgReplace = '  ' + p_MsgReplace;
001422150601 1e    endif;
001423150601
001424150601       // call retrieve message API to pull in substitution variables
001425150601       callp QMHRTVM(
001426150601             QmhrtvmDS :
001427150601             mMsgLen :
001428150601             'RTVM0100':
001429150601             p_ErrMsgID:
001430150601             mMsgf:
001431150601             p_MsgReplace:
001432150601             %size(p_MsgReplace):
001433150601             '*YES      ':
001434150601             '*NO       ':
001435150601             ApiErrDS);
001436150601       // If too long, set length to size of return value
001437150601 1b    if QmhrtvmDS.MessageRtvLen > %size(QmhrtvmDS.MessageRtv);
001438150601          QmhrtvmDS.MessageRtvLen = %size(QmhrtvmDS.MessageRtv);
001439150601 1e    endif;
001440150601       // Only return populated message length
001441150601       Return  %subst(QmhrtvmDS.MessageRtv: 1: QmhrtvmDS.MessageRtvLen);
001442150610      /end-free
001443150601     P f_RtvMsgAPI...
001444150601     P                 E
001445150601       //---------------------------------------------------------
001446150601       // Send message to error message subfile
001447150601     P f_SndSflMsg     B                   export
001448150601     D f_SndSflMsg     PI
001449150601     D  p_ProgName                   10a   const
001450150601     D  p_MsgTxt                     75a   const
001451150601     D  p_MsgID                       7a   const   options(*nopass)
001452150601     D  p_MsgFile                    10a   const   options(*nopass)
001453150601     D  p_MsgLib                     10a   const   options(*nopass)
001454150601
001455150603     D  MsgID          S              7a
001456150603     D  MsgFileQual    S             20a
001457150601
001458150610      /free
001459150601 1b    if %parms < 3;
001460150601          clear msgid;
001461150601          clear MsgFileQual;
001462150601 1x    else;
001463150601          msgid = p_MsgID;
001464150601 2b       if %parms < 5;
001465150601             msgFileQual = p_MsgFile + '*LIBL  ';
001466150601 2x       else;
001467150601             msgFileQual = p_MsgFile + p_MsgLib;
001468150601 2e       endif;
001469150601 1e    endif;
001470150601
001471150601       callp QMHSNDPM(
001472150601             msgid:
001473150601             msgFileQual:
001474150601             p_MsgTxt:
001475150601             %len(p_MsgTxt):
001476150601             '*INFO':
001477150601             p_ProgName:
001478150601             0:
001479150601             '    ':
001480150601             ApiErrDs);
001481150601       return;
001482150610      /end-free
001483150601     P f_SndSflMsg...
001484150601     P                 E
001485150601
001486150601       // Execute C function system using global exception variable
001487150603     P f_System        B                   export
001488150603     D f_System        PI                  opdesc
001489150603     D  p_String                   2048a   const options(*varsize)
001490150601
001491150610      /free
001492150601        CEEGSI(1: DataType: ParmLen: MaxLen: *omit);
001493150601        EXCP_MSGID = *blanks;
001494150601 1b     if system(%subst(p_String: 1: ParmLen)) = 1
001495150601           and EXCP_MSGID > *blanks;
001496150601           ApiErrDS.ErrMsgId = EXCP_MSGID;
001497150601
001498150601 2b        if  ApiErrDS.ErrMsgId = 'CPF6801';   //f3 or f12 pressed
001499150601              ApiErrDS.MsgReplaceVal = 'F3';
001500150601 2x        else;
001501150601              ApiErrDS.MsgReplaceVal = *blanks;
001502150601 2e        endif;
001503150601
001504150601           ApiErrDS.BytesReturned = 7;
001505150601 1x     else;
001506150601           ApiErrDS.BytesReturned = 0;
001507150601 1e     endif;
001508150601        return;
001509150610      /end-free
001510150603     P f_System        E
001511150601
